      SUBROUTINE SLSBT (WM, IWM, X, TEM)
CLLL. OPTIMIZE
      INTEGER IWM
      INTEGER LBLOX, LPB, LPC, MB, NB
      DOUBLE PRECISION WM, X, TEM
      DIMENSION WM(1), IWM(1), X(1), TEM(1)
C-----------------------------------------------------------------------
C THIS ROUTINE ACTS AS AN INTERFACE BETWEEN THE CORE INTEGRATOR
C ROUTINE AND THE SOLBT ROUTINE FOR THE SOLUTION OF THE LINEAR SYSTEM 
C ARISING FROM CHORD ITERATION.
C COMMUNICATION WITH SLSBT USES THE FOLLOWING VARIABLES..
C WM    = REAL WORK SPACE CONTAINING THE LU DECOMPOSITION,
C         STARTING AT WM(3).
C IWM   = INTEGER WORK SPACE CONTAINING PIVOT INFORMATION, STARTING AT
C         IWM(21).  IWM ALSO CONTAINS BLOCK STRUCTURE PARAMETERS
C         MB = IWM(1) AND NB = IWM(2).
C X     = THE RIGHT-HAND SIDE VECTOR ON INPUT, AND THE SOLUTION VECTOR
C         ON OUTPUT, OF LENGTH N.
C TEM   = VECTOR OF WORK SPACE OF LENGTH N, NOT USED IN THIS VERSION. 
C-----------------------------------------------------------------------
      MB = IWM(1)
      NB = IWM(2)
      LBLOX = MB*MB*NB
      LPB = 3 + LBLOX
      LPC = LPB + LBLOX
      CALL SOLBT (MB, NB, WM(3), WM(LPB), WM(LPC), X, IWM(21))
      RETURN
C----------------------- END OF SUBROUTINE SLSBT -----------------------
      END 
